#include "hwp.h"

#ifdef __STDC__
int edit_menu(void)
#else
int edit_menu()
#endif
{
	WINDOW *edit_win;

	int inputch=0,pos=0;

	edit_win=newwin(12,19,1,11);

	mybox(edit_win,12,19);

	wattron(edit_win,A_REVERSE);

	mvwaddstr(edit_win,1,1,"Edit Header");

	wattroff(edit_win,A_REVERSE);

	mvwaddstr(edit_win,2,1,"Edit Footer");

	mvwaddstr(edit_win,3,1,"Start Underline");

	mvwaddstr(edit_win,4,1,"End Underline");

	mvwaddstr(edit_win,5,1,"Start Bold");

	mvwaddstr(edit_win,6,1,"End Bold");

	mvwaddstr(edit_win,7,1,"Start Superscript");

	mvwaddstr(edit_win,8,1,"End Superscript");

	mvwaddstr(edit_win,9,1,"Start Subscript");

	mvwaddstr(edit_win,10,1,"End Subscript");

	keypad(edit_win,TRUE);

	wmove(edit_win,1,1);

	wrefresh(edit_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(edit_win,1,1,"Edit Header");

				break;

			case 1:	mvwaddstr(edit_win,2,1,"Edit Footer");

				break;

			case 2:	mvwaddstr(edit_win,3,1,"Start Underline");

				break;

			case 3:	mvwaddstr(edit_win,4,1,"End Underline");

				break;

			case 4:	mvwaddstr(edit_win,5,1,"Start Bold");

				break;

			case 5:	mvwaddstr(edit_win,6,1,"End Bold");

				break;

			case 6: mvwaddstr(edit_win,7,1,"Start Superscript");

				break;

			case 7: mvwaddstr(edit_win,8,1,"End Superscript");

				break;

			case 8: mvwaddstr(edit_win,9,1,"Start Subscript");

				break;

			case 9: mvwaddstr(edit_win,10,1,"End Subscript");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=10;

					break;

			case KEY_RIGHT:	werase(edit_win);

					wrefresh(edit_win);

					delwin(edit_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(edit_win);

					wrefresh(edit_win);

					delwin(edit_win);

					display_screen();

					return -2;
		}

		pos=pos%10;

		wattron(edit_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(edit_win,1,1,"Edit Header");
				wmove(edit_win,1,1);

				break;

			case 1:	mvwaddstr(edit_win,2,1,"Edit Footer");
				wmove(edit_win,2,1);

				break;

			case 2:	mvwaddstr(edit_win,3,1,"Start Underline");
				wmove(edit_win,3,1);

				break;

			case 3:	mvwaddstr(edit_win,4,1,"End Underline");
				wmove(edit_win,4,1);

				break;

			case 4:	mvwaddstr(edit_win,5,1,"Start Bold");
				wmove(edit_win,5,1);

				break;

			case 5: mvwaddstr(edit_win,6,1,"End Bold");
				wmove(edit_win,6,1);

				break;

			case 6: mvwaddstr(edit_win,7,1,"Start Superscript");
				wmove(edit_win,7,1);

				break;

			case 7: mvwaddstr(edit_win,8,1,"End Superscript");
				wmove(edit_win,8,1);

				break;

			case 8: mvwaddstr(edit_win,9,1,"Start Subscript");
				wmove(edit_win,9,1);

				break;

			case 9: mvwaddstr(edit_win,10,1,"End Subscript");
				wmove(edit_win,10,1);

				break;
		}

		wattroff(edit_win,A_REVERSE);

		wrefresh(edit_win);
	}

	werase(edit_win);

	wrefresh(edit_win);

	delwin(edit_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	switch(pos)
	{
		case 0:	get_inputline("Change header (first % will be page no.):",header,header);

			return 0;

		case 1:	get_inputline("Change footer (first % will be page no.):",footer,footer);

			return 0;

		case 2:	current_attr|=START_UNDERLINE;

			return 0;

		case 3:	current_attr&=~START_UNDERLINE;

			return 0;

		case 4:	current_attr|=START_BOLD;

			return 0;

		case 5:	current_attr&=~START_BOLD;

			return 0;

		case 6:	current_attr|=START_SUPERSCRIPT;

			return 0;

		case 7: current_attr&=~START_SUPERSCRIPT;

			return 0;

		case 8:	current_attr|=START_SUBSCRIPT;

			return 0;

		case 9: current_attr&=~START_SUBSCRIPT;

			return 0;

	}

	return 0;
}
