#include "hwp.h"

#include <string.h>

#ifdef __STDC__
int options_menu(void)
#else
int options_menu()
#endif
{
	WINDOW *options_win;

	int inputch=0,pos=0,tmpint;

	char tmpstr[69];

	options_win=newwin(12,19,1,35);

	mybox(options_win,12,19);

	wattron(options_win,A_REVERSE);

	mvwaddstr(options_win,1,1,"Line Spacing");

	wattroff(options_win,A_REVERSE);

	mvwaddstr(options_win,2,1,"Page Length");

	mvwaddstr(options_win,3,1,"Tab Size");

	mvwaddstr(options_win,4,1,"Indentation Size");

	mvwaddstr(options_win,5,1,"Left Margin");

	mvwaddstr(options_win,6,1,"Right Margin");

	mvwaddstr(options_win,7,1,"Top Blanks");

	mvwaddstr(options_win,8,1,"Bottom Blanks");

	mvwaddstr(options_win,9,1,"Starting Page #");

	mvwaddstr(options_win,10,1,"Toggle Insertmode");

	keypad(options_win,TRUE);

	wmove(options_win,1,1);

	wrefresh(options_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(options_win,1,1,"Line Spacing");

				break;

			case 1:	mvwaddstr(options_win,2,1,"Page Length");

				break;

			case 2:	mvwaddstr(options_win,3,1,"Tab Size");

				break;

			case 3:	mvwaddstr(options_win,4,1,"Indentation Size");

				break;

			case 4:	mvwaddstr(options_win,5,1,"Left Margin");

				break;

			case 5:	mvwaddstr(options_win,6,1,"Right Margin");

				break;

			case 6:	mvwaddstr(options_win,7,1,"Top Blanks");

				break;

			case 7:	mvwaddstr(options_win,8,1,"Bottom Blanks");

				break;

			case 8:	mvwaddstr(options_win,9,1,"Starting Page #");

				break;

			case 9:	mvwaddstr(options_win,10,1,"Toggle Insertmode");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=10;

					break;

			case KEY_RIGHT:	werase(options_win);

					wrefresh(options_win);

					delwin(options_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(options_win);

					wrefresh(options_win);

					delwin(options_win);

					display_screen();

					return -2;
		}

		pos=pos%10;

		wattron(options_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(options_win,1,1,"Line Spacing");
				wmove(options_win,1,1);

				break;

			case 1:	mvwaddstr(options_win,2,1,"Page Length");
				wmove(options_win,2,1);

				break;

			case 2:	mvwaddstr(options_win,3,1,"Tab Size");
				wmove(options_win,3,1);

				break;

			case 3:	mvwaddstr(options_win,4,1,"Indentation Size");
				wmove(options_win,4,1);

				break;

			case 4:	mvwaddstr(options_win,5,1,"Left Margin");
				wmove(options_win,5,1);

				break;

			case 5:	mvwaddstr(options_win,6,1,"Right Margin");
				wmove(options_win,6,1);

				break;

			case 6:	mvwaddstr(options_win,7,1,"Top Blanks");
				wmove(options_win,7,1);

				break;

			case 7:	mvwaddstr(options_win,8,1,"Bottom Blanks");
				wmove(options_win,8,1);

				break;

			case 8:	mvwaddstr(options_win,9,1,"Starting Page #");
				wmove(options_win,9,1);

				break;

			case 9:	mvwaddstr(options_win,10,1,"Toggle Insertmode");
				wmove(options_win,10,1);

				break;
		}

		wattroff(options_win,A_REVERSE);

		wrefresh(options_win);
	}

	werase(options_win);

	wrefresh(options_win);

	delwin(options_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	switch(pos)
	{
		case 0:	sprintf(tmpstr,"%d",line_spacing+1);

			if (get_inputline("Change line spacing:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>0&&tmpint<4)
					line_spacing=tmpint-1;
				else
					error_message("Didn't change line spacing because:","Incorrect number entered - must be between 1 and 3.");
			}

			return 0;

		case 1:	sprintf(tmpstr,"%d",page_length);

			if (get_inputline("Change page length:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>0&&tmpint<201)
					page_length=tmpint;
				else
					error_message("Didn't change page length because:","Incorrect number entered - must be between 1 and 200.");
			}

			return 0;

		case 2: sprintf(tmpstr,"%d",tab_size);

			if (get_inputline("Change Tab size:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>0&&tmpint<17)
					tab_size=tmpint;
				else
					error_message("Didn't change Tab size because:","Incorrect number entered - must be between 1 and 16.");
			}

			return 0;

		case 3:	sprintf(tmpstr,"%d",indent+1);

			if (get_inputline("Change indentation size:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				tmpint--;

				if (tmpint>=left_margin&&tmpint<=right_margin)
					indent=tmpint;
				else
					error_message("Didn't change indentation size because:","Incorrect number entered - must be between left and right margin.");
			}

			return 0;

		case 4:	sprintf(tmpstr,"%d",left_margin+1);

			if (get_inputline("Change left margin:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				tmpint--;

				if (tmpint<=indent&&tmpint<right_margin&&tmpint>=0)
					left_margin=tmpint;
				else
					error_message("Didn't change left margin because:","Incorrect number entered - must be between indentation and right margin.");
			}

			return 0;

		case 5:	sprintf(tmpstr,"%d",right_margin+1);

			if (get_inputline("Change right margin:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				tmpint--;

				if (tmpint>left_margin&&tmpint<=78)
					right_margin=tmpint;
				else
					error_message("Didn't change right margin because:","Incorrect number entered - must be greater than left margin and less than 80.");
			}

			return 0;

		case 6:	sprintf(tmpstr,"%d",top_blanks);

			if (get_inputline("Change top blanks:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>1&&tmpint<11)
					top_blanks=tmpint;
				else
					error_message("Didn't change top blanks because:","Incorrect number entered - must be between 2 and 10.");
			}

			return 0;

		case 7:	sprintf(tmpstr,"%d",bottom_blanks);

			if (get_inputline("Change bottom blanks:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>1&&tmpint<11)
					bottom_blanks=tmpint;
				else
					error_message("Didn't change bottom blanks because:","Incorrect number entered - must be between 2 and 10.");
			}

			return 0;

		case 8:	sprintf(tmpstr,"%d",starting_page_no);

			if (get_inputline("Change starting page #:",tmpstr,tmpstr)!=-1)
			{
				sscanf(tmpstr,"%d",&tmpint);

				if (tmpint>0&&tmpint<201)
					starting_page_no=tmpint;
				else
					error_message("Didn't change starting page # because:","Incorrect number entered - must be between 1 and 200.");
			}

			return 0;

		case 9:	insertmode=(insertmode==INSERT)?OVERSTRIKE:INSERT;

			mvprintw(LINES-2,0," Title: %s Page: %d Line: %d     ",(strrchr(filename,'/'))?strrchr(filename,'/')+1:filename,((current_page-1)*LINES_PER_PAGE+current_y)/(page_length-(top_blanks+bottom_blanks))+1,current_y+1+(current_page-1)*LINES_PER_PAGE);

			if (insertmode==OVERSTRIKE)
				mvprintw(LINES-2,69,"Overstrike");
			else
				mvprintw(LINES-2,69,"Insert    ");

			if (current_attr&START_BOLD)
				mvprintw(LINES-2,64,"Bold");
			else
				mvprintw(LINES-2,64,"    ");
		
			if (current_attr&START_UNDERLINE)
				mvprintw(LINES-2,54,"Underline");
			else
				mvprintw(LINES-2,54,"         ");

			return 0;
	}

	return 0;
}
