#include "hwp.h"

#ifdef __STDC__
void display_screen(void)
#else
void display_screen()
#endif
{
	int row,col,bold_on=0,underline_on=0,superscript_on=0,subscript_on=0,block_on=0;

	werase(textscr);

	wattrset(textscr,A_NORMAL);

	for (row=0;row<LINES_PER_PAGE;row++)
	{
		for (col=0;col<80;col++)
		{
			if ((row+(current_page-1)*LINES_PER_PAGE)>=numlines)
				continue;

			wmove(textscr,row,col);

			if ((row+(current_page-1)*LINES_PER_PAGE)==lowmark||(row+(current_page-1)*LINES_PER_PAGE)==highmark||((row+(current_page-1)*LINES_PER_PAGE)>lowmark&&((row+(current_page-1)*LINES_PER_PAGE)<highmark)))
			{
				wattron(textscr,A_REVERSE);

				block_on=1;
			}
			else
			{
				if (block_on==1)
				{
					block_on=0;

					wattroff(textscr,A_REVERSE);
				}
					
				if (!bold_on)
				{
					if (file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_BOLD)
					{
						bold_on=1;
						wattron(textscr,A_BOLD);
					}
				}
				else
				{
					if (!(file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_BOLD))
					{
						bold_on=0;
						wattroff(textscr,A_BOLD);
					}
				}
	
				if (!underline_on)
				{
					if (file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_UNDERLINE)
					{
						underline_on=1;
						wattron(textscr,underline_char);
					}
				}
				else
				{
					if (!(file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_UNDERLINE))
					{
						underline_on=0;
						wattroff(textscr,underline_char);
					}
				}
	
				if (!superscript_on)
				{
					if (file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_SUPERSCRIPT)
					{
						superscript_on=1;
						wattron(textscr,A_REVERSE);
					}
				}
				else	
				{
					if (!(file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_SUPERSCRIPT))
					{
						superscript_on=0;
						wattroff(textscr,A_REVERSE);
					}
				}
	
				if (!subscript_on)
				{
					if (file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_SUBSCRIPT)
					{
						subscript_on=1;
						wattron(textscr,A_REVERSE);
					}
				}
				else
				{
					if (!(file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&START_SUBSCRIPT))
					{
						subscript_on=0;
						wattroff(textscr,A_REVERSE);
					}
				}
			}
	
			if (file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&0xff)
				waddch(textscr,((int)file_buffer[col+(row+(current_page-1)*LINES_PER_PAGE)*LINE_LENGTH]&0xff));
			else
				waddch(textscr,' ');
		}
	}
			
	wmove(textscr,current_y,current_x);

	wattrset(textscr,A_NORMAL);

	wrefresh(textscr);
}
