#include "hwp.h"

#ifdef __STDC__
void do_help(void)
#else
void do_help()
#endif
{
	werase(textscr);

	mvwaddstr(textscr,0,0,"hwp is Copyright 1994, Harry C. Pulley, IV.  hwp may be copied freely.");

	mvwaddstr(textscr,2,0,"To activate the menubar, press F10.  To use a specific function press the");
	mvwaddstr(textscr,3,0,"appropriate function key.  Once in the menubar, use the arrow keys to navigate");
	mvwaddstr(textscr,4,0,"the menubar; use Enter, Up or Down to select a menu.  Once in a menu, use the");
	mvwaddstr(textscr,5,0,"Up and Down keys to move to the desired selection; use the Enter key to select.");
	mvwaddstr(textscr,6,0,"ESC cancels either the menubar or a menu.");
	mvwaddstr(textscr,7,0,"hwp automatically word wraps in both insert and overstrike mode.  Use the arrow");
	mvwaddstr(textscr,8,0,"keys, pageup/down and home/end to move around.  Use Delete and Backspace to");
	mvwaddstr(textscr,9,0,"erase text.  To change the insert mode use the Insert key (^T) or choose Toggle");
	mvwaddstr(textscr,10,0,"Insertmode from the Options menu.  To change your header or footer, use the");
	mvwaddstr(textscr,11,0,"Etc. menu.  To load, save, print (Epson or Postscript), or start a new file or");
	mvwaddstr(textscr,12,0,"quit use the File menu; to save a file as ASCII use an ending other than .hwp,");
	mvwaddstr(textscr,13,0,".out or .ps.  To change margins, tab size, etc. use the Options menu.  To find");
	mvwaddstr(textscr,14,0,"words in the text, use the find menu.  To check the spelling of your document,");
	mvwaddstr(textscr,15,0,"use the Spell menu; choose Next Incorrect Word to go to the next misspelled");
	mvwaddstr(textscr,16,0,"word; choose Skip Current Word to skip all occurances of a word.  Block menu");
	mvwaddstr(textscr,17,0,"does block operations (cut, paste, copy, delete, mark).  ^L refreshes the");
	mvwaddstr(textscr,18,0,"screen.");
#if 0
	mvwaddstr(textscr,18,0,"screen; ^C cut; ^P paste; ^D delete; ^X mark; ^U toggle underline; ^B toggle");
	mvwaddstr(textscr,19,0,"bold; ^S save file; ^Q quit; ^F find next; ^N next incorrect word; ^K skip");
	mvwaddstr(textscr,20,0,"current misspelled word.");
#endif

	wrefresh(textscr);

	attron(A_BOLD);

	mvaddstr(LINES-1,0," Press any key to continue...                                                ");
	mvaddstr(LINES-1,0," Press any key to continue...");

	attroff(A_BOLD);

	wrefresh(stdscr);

	while (getch()==12)
		wrefresh(curscr);

	attron(A_BOLD);

	mvaddstr(LINES-1,0," Press function key to activate menu.  Or press F10 to activate menu bar.      ");

	attroff(A_BOLD);

	wrefresh(stdscr);

	display_screen();
}
