#include <unistd.h>

#include "hwp.h"

#ifdef __STDC__
int file_menu(void)
#else
int file_menu()
#endif
{
	WINDOW *file_win;

	int inputch=0,pos=0;

	file_win=newwin(9,18,1,0);

	mybox(file_win,9,18);

	wattron(file_win,A_REVERSE);

	mvwaddstr(file_win,1,1,"Load File");

	wattroff(file_win,A_REVERSE);

	mvwaddstr(file_win,2,1,"Bring in File");

	mvwaddstr(file_win,3,1,"Save File");

	mvwaddstr(file_win,4,1,"Print Epson");

	mvwaddstr(file_win,5,1,"Print Postscript");

	mvwaddstr(file_win,6,1,"New");

	mvwaddstr(file_win,7,1,"Quit");

	keypad(file_win,TRUE);

	wmove(file_win,1,1);

	wrefresh(file_win);

	while(inputch!='\n'&&inputch!='\r'&&inputch!=27)
	{
		inputch=getch();

		switch(pos)
		{
			case 0:	mvwaddstr(file_win,1,1,"Load File");

				break;

			case 1: mvwaddstr(file_win,2,1,"Bring in File");

				break;

			case 2: mvwaddstr(file_win,3,1,"Save File");

				break;

			case 3: mvwaddstr(file_win,4,1,"Print Epson");

				break;

			case 4: mvwaddstr(file_win,5,1,"Print Postscript");

				break;

			case 5: mvwaddstr(file_win,6,1,"New");

				break;

			case 6: mvwaddstr(file_win,7,1,"Quit");

				break;
		}

		switch(inputch)
		{
			case 12:	wrefresh(curscr);

					break;

			case KEY_DOWN:	pos++;

					break;

			case KEY_UP:	pos--;

					if(pos<0)
						pos+=7;

					break;

			case KEY_RIGHT:	werase(file_win);

					wrefresh(file_win);

					delwin(file_win);

					display_screen();

					return -1;

			case KEY_LEFT:	werase(file_win);

					wrefresh(file_win);

					delwin(file_win);

					display_screen();

					return -2;
		}

		pos=pos%7;

		wattron(file_win,A_REVERSE);

		switch(pos)
		{
			case 0:	mvwaddstr(file_win,1,1,"Load File");
				wmove(file_win,1,1);

				break;

			case 1: mvwaddstr(file_win,2,1,"Bring in File");
				wmove(file_win,2,1);

				break;

			case 2: mvwaddstr(file_win,3,1,"Save File");
				wmove(file_win,3,1);

				break;

			case 3: mvwaddstr(file_win,4,1,"Print Epson");
				wmove(file_win,4,1);

				break;

			case 4: mvwaddstr(file_win,5,1,"Print Postscript");
				wmove(file_win,5,1);

				break;

			case 5: mvwaddstr(file_win,6,1,"New");
				wmove(file_win,6,1);

				break;

			case 6: mvwaddstr(file_win,7,1,"Quit");
				wmove(file_win,7,1);

				break;
		}

		wattroff(file_win,A_REVERSE);

		wrefresh(file_win);
	}

	werase(file_win);

	wrefresh(file_win);

	delwin(file_win);

	display_screen();

	if (inputch==27)
		return 0;

	attron(A_REVERSE);

	mvaddstr(0,0,"                                                                        F1:Help ");

	attroff(A_REVERSE);

	wrefresh(stdscr);

	switch(pos)
	{
		case 0:	load_file();

			display_screen();

			return 0;

		case 1:	bring_in_file();

			display_screen();

			return 0;

		case 2:	write_file();

			return 0;

		case 3: print_file();

			return 0;

		case 4: do_write_nrout("SPOOLER .ps");

			return 0;

		case 5:	if (changed)
			{
				if (confirm_load()==0)
					return 0;
			}

			unlink("untitled.hwp");

			do_load_file("untitled.hwp");

			display_screen();

			return 0;

		case 6:	if (confirm_quit())
				return 1;
			else
				return 0;
	}

	return 0;
}
